<html>
<head>
<title>RManNotes: Stochastic Patterns: Noise</title>
</head>

<body bgcolor="#f9f9b1" background="notepad.gif" link="801010" vlink="101080" alink="108010"> <img alt="RManNotes" align=center src="header.gif">

<img align=center hspace=10 src="stoch_patterns.gif">

<p><img src="black_line.gif"></p>
<p>
<a href="index.html">previous</a>
|
<a href="turbulence.html">next</a>
|
<a href="index.html">stochastic patterns: <b>contents</b></a>
|
<a href="../index.html">rmannotes: <b>top</b></a>
</i>
</p>
<p><img src="black_line.gif"></p>

<h1><a name="noise">Noise</a></h1>

<p>
Irregular patterns have <i>stochastic</i> components. In this context, stochastic functions appear random but actually aren't random at all. Rather, they are <i>pseudo-random</i> -- functions which appear to have random output 
but are actually repeatable given the same input. The basic tool for
building stochastic functions is the <i>noise</i> function 
<a href="../references.html">[Ebert94]</a>
<a href="../references.html">[Perlin85]</a>
<a href="../references.html">[Perlin89]</a>
<a href="../references.html">[Lewis89]</a>
.
</p>

<p>
There are many ways to implement a "noise" function.
The RManNotes pages will focus on the use of noise as implemented in
PRMan and BMRT. You should consult 
<a href="../references.html">[Ebert94]</a>
for an excellent survey of properties and implementations
of various noise functions (esp Chapter 2 by Peachey).
</p>

<p align=center>
<img src="noise.gif">
<br>One-dimensional noise.
<br><small>Adapted from 
<a href="../references.html">[Apodaca92]</a>.</small>
</p>

<p>
The <code>noise</code> function in the RenderMan Shading Langauge has several important characteristics:
<ul>
<li>1D (1 float), 2D (2 floats), or 3D (1 point) input
<li>float, color, or point output (programmer should cast to desired type)
<li>output values in the range [0, 1]
<li>the output value is 0.5 for integer inputs
<li>continuous and smooth
<li>dominant frequency of 0.5 to 1
<li>repeatable (given the same input, it will allows produce the same output)
</ul>
</p>

<center><img src="noise2.gif">
<br>Two-dimensional noise (<code>float</code> output). 
<br><code>Ci = float noise(s * 5, t * 5)</code>
</center>
<p>

<center><img src="noise2c.gif">
<br>Two-dimensional noise (<code>color</code> output). 
<br><code>Ci = color noise(s * 5, t * 5)</code>
</center>
<p>

The input of noise is commonly manipulated using simple transformations such as shifting by an offset 
or scaling by some frequency. For example,
<pre>
	noise(x + offset)
</pre>
adds an offset to the noise inputs which results in shifting the outputs. While,
<pre>
	noise(x * frequency)
</pre>
increases or decreases the frequency (for frequency values greater than 1 or less than 1 respectively). Most commonly, both of these transformations are used along with an output scaling factor to 
adjust amplitude.
<pre>
	noise(x * frequency + offset) * amplitude
</pre>

<h2><a name="snoise">Signed Noise</a></h2>

<p>
It's not always convenient to have a noise function with strictly positive outputs. The <i><b>snoise</b></i> function 
produces a 1D (input and output) noise function with output values in the range [-1,1] in the spirit 
of the noise function described by 
<a href="../references.html">[Perlin85]</a>.
</p>

<table border=3 cellpadding=5 width=100%>
<tr><td>
<p align=right><small>RManNotes function</small></p>
<p>
<b>float snoise(float x)</b><br>
<b>float snoise(point x)</b><br>
<b>float snoise2(float x, y)</b>
</p>
<p>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<i>These return the value of noise scaled to [-1,1]. 
Note: the 1D and 3D functions have the same name.
</i></p>
</table>

<h2><a name="udn">Uniformly Distributed Noise</h2>

<p>
The noise function has a tendency to generate output values which 
lie near the value 0.5. <i><b>udn</b></i> and <i><b>udn2</b></i>
(Uniformly Distributed Noise)
can be used instead of noise to generate values which are more uniformly
distributed over some range.
</p>

<table border=3 cellpadding=5 width=100%>
<tr><td>
<p align=right><small>RManNotes function</small></p>
<p>
<b>float udn(float x, lo, hi)</b><br>
<b>float udn(point x; float lo, hi)</b><br>
<b>float udn2(float x, y, lo, hi)</b>
</p>
<p>
&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;
<i>1D, 3D, and 2D uniformly distributed noise over the range
<i>lo</i> to <i>hi</i>.
Note: the 1D and 3D functions have the same name.
</i></p>
</table>

<p>
A uniform distribution of values is particularly useful when
randomly varying some pattern.  For example, if you used noise to randomly 
choose a solid color for each tile in a regular pattern, it is likely that
some colors would
appear more frequently than others. This is not as likely to happen if
you use <code>udn</code> instead.

<p><img src="black_line.gif"></p>
<p>
<a href="index.html">previous</a>
|
<a href="turbulence.html">next</a>
|
<a href="index.html">stochastic patterns: <b>contents</b></a>
|
<a href="../index.html">rmannotes: <b>top</b></a>
</i>
</p>

<p><img src="black_line.gif"></p> <small> <p><i>RManNotes</i> is Copyright &copy; 1995, 1996 Stephen F. May</p> <p> <i>Any comments or suggestions appreciated.</i> <address><a href="http://www.cgrg.ohio-state.edu/~smay">Steve May</a> (<a href="mailto:smay@cgrg.ohio-state.edu">smay@cgrg.ohio-state.edu</a>)</address> </p> </small>

<p align=right><small><i>Last Modified: 4/16/96</i></small></p>

</body>
</html>
